var utr = //Unit Test Runner
{
    RUNNER_BAR_ID :"runnerBar",
    TEST_RUNNER_TITLE_ID :"testRunnerTitle",

    _suiteButtonSize: "mediumButton button",
    _rowHeightClass:"stdRowHeight",
    _testResults:{},

    SetSuiteButtonSize: function (buttonSize)
    {
        utr._suiteButtonSize = buttonSize;
        uts.GetSuiteList();
    },
    
    SetRowSize: function (rowSize)
{
	row_height_btn = $("rowHeightButton");
	if (utr._rowHeightClass != rowSize)
	{
		utr._rowHeightClass = rowSize;
		row_height_btn.value = "Decrease"
	}
	else
	{ 
		utr._rowHeightClass = "stdRowHeight";
		row_height_btn.value = "Increase"
	}
	utr.CreateFullTable(utr._testResults);
},

    UpdateCheckedSuiteButton : function ()
    {
        if (utr._suiteButtonSize.search(/small/) != -1) $("smallButton").checked = true;
        else if (utr._suiteButtonSize.search(/medium/) != -1) $("mediumButton").checked = true;
        else if (utr._suiteButtonSize.search(/large/) != -1) $("largeButton").checked = true;
        else $("mixedButton").checked = true;
    },

    CreateSuiteList : function (testResults)
    {
        var suite_list_obj = syn.EvalJsonObject(testResults);
        if (suite_list_obj == null) return;
        //        $('objectSample').innerHTML = syn.DescribeObject(suite_list_obj);
        var parent_node = $('buttonBar1');
        syn.RemoveAllChildren(parent_node);
        if (parent_node == null)
        {
            $('objectSample').innerHTML = "parent_node for buttonBar1 was null.";
        }
        utr.CreateButton("All", parent_node);
        var array_length = suite_list_obj.suiteNames.length;
        for (var i = 0; i < array_length; ++i)
        {
            var btn_name = suite_list_obj.suiteNames[i];
            utr.CreateButton(btn_name, parent_node);
        }

        utr.UpdateCheckedSuiteButton();
    },

    CreateMixedSizeButton : function (theButton)
    {
        theButton.className = "mediumButton button";
        if (theButton.value.length > 17)
        {
            theButton.className = "largeButton button"
        }
        else if (theButton.value.length < 12)
        {
            theButton.className = "smallButton button"
        }
    },

    CreateButton : function(buttonName, parentNode)
    {
        // <input id="testButton" type="button" class="button" name="my name" value="My button"/>
        var new_button = document.createElement("input");
        new_button.value = buttonName;
        new_button.type = "button";
        if (utr._suiteButtonSize == "Mixed")utr.CreateMixedSizeButton(new_button);
        else new_button.className = utr._suiteButtonSize;


        //uts.ReqExampleSuite('ExampleSuite'
        //new_button.onclick =  uts.RunSuite(buttonName);
        new_button.onclick = function() {
            uts.RunSuite(buttonName);
        };
        parentNode.appendChild(new_button);
    },
    //    EXAMPLE OF what returned object will look like. Array objects may have any number of items.
    //		string expected = "{objName: \"ReportSummary\",totalTestCount: 1,failedTestCount: 1,failureCount: 2,secondsElapsed: 0.2,"
    //			"tableHeaders: [\"Result\",\"Suite\",\"TestName\",\"Error Message\"],"
    //			"testResults: [{testName: \"FailedTest\",suiteName: \"suite\",elapsedTime: 0.1,failed: 1,"
    //			"failureMessages: [\"fail.h(1) : First failure message\",\"fail.h(31) : Second failure message\"]}]}";
    CreateResultTable : function (testResults)
    {

        var testObject = syn.EvalJsonObject(testResults);
        if (testObject == null) return;
        utr._testResults = testObject;
        utr.CreateFullTable(testObject);

    },

	CreateFullTable: function (testObject)
{
	     utr.SetRunnerBarResultColor(testObject);

        var grandparent_node = $(uts.UNIT_TEST_INFO_ID);
        syn.RemoveAllChildren(grandparent_node);
        window.status = "Formatting results...";

        utr.CreateHeaders(grandparent_node, testObject);
        utr.CreateResultsRows(grandparent_node, testObject);
        utr.CreateSummaryRow(grandparent_node, testObject);
        window.status = "";
},
    CreateHeaders: function (grandparentNode, testObject)
    {
    	if (testObject.tableHeaders == null) return;
        var parent_node = document.createElement("div");
        parent_node.className = utr._rowHeightClass + " "+uts.HEADER_CLASS;
        parent_node.id = "resultHeader";
        grandparentNode.appendChild(parent_node);
        var class_collection = [uts.STATUS_COL_CLASS, uts.SUITE_NAME_COL_CLASS, uts.TEST_NAME_COL_CLASS, uts.ERROR_RESULT_COL_CLASS];

        for (var i = 0; i < uts.NUMBER_TEST_RESULT_COLS; ++i)
        {
            class_to_use = " propHeader propValue " + class_collection[i];
            var header_text = testObject.tableHeaders[i];
            var child_node = utr.CreateSpan("", class_to_use, header_text);
            parent_node.appendChild(child_node);
        }
    },

    SetRunnerBarResultColor: function (testObject)
    {
        var runner_node = $(utr.RUNNER_BAR_ID);
         //Also set page header text
        var page_title = $(utr.TEST_RUNNER_TITLE_ID);
        
        runner_node.className = "runnerBar ";
        page_title.className = "TitleRight";
        if (testObject.failedTestCount > 0)
        {
            runner_node.className = "runnerBar failed";
            page_title.className = "TitleRight failedColor";
        }
        else
        { 
        	  runner_node.className = "runnerBar passed";
           page_title.className = "TitleRight passedColor";
        }
       
        
    },


    GetStatusColumn : function (failed)
    {
        var status_text = " Passed";
        var status_image = document.createElement("img");
        status_image.src = "images/pass.png";
        status_image.setAttribute('src', 'images/pass.png');

        if (failed)
        {
            status_text = " Failed";
            status_image.setAttribute('src', 'images/fail.png')
        }

        var child_node = utr.CreateSpan("", "propValue "+uts.STATUS_COL_CLASS, status_text);
        child_node.insertBefore(status_image, child_node.firstChild);
        return child_node;
    },

    CreateResultsRows : function (grandparentNode, testObject)
    {
    	if (testObject.testResults == null) return;
        var parent_node = document.createElement("div");
        parent_node.id = "testResults";
        parent_node.className = "testResultRow";
        grandparentNode.appendChild(parent_node);

        var num_results = testObject.testResults.length;
        for (var i = 0; i < num_results; ++i)
        {

            var result_line = testObject.testResults[i];
            parent_node.appendChild(utr.GetStatusColumn(result_line.failed));

            var child_node = utr.CreateSpan("", "propValue " +uts.SUITE_NAME_COL_CLASS, result_line.suiteName);
            parent_node.appendChild(child_node);
            child_node = utr.CreateSpan("", "propValue " +uts.TEST_NAME_COL_CLASS, result_line.testName);
            parent_node.appendChild(child_node);
            child_node = utr.CreateSpan("","propValue " + uts.ERROR_RESULT_COL_CLASS, "");
            utr.CreateFullFailureMsg(child_node, result_line.failureMessages);
            parent_node.appendChild(child_node);
        }
    },

    CreateSummaryRow : function (grandparentNode, testObject)
    {
        if (testObject.totalTestCount == null) return;
        
        var parent_node = utr.CreateDiv("", uts.SUMMARY_CLASS, "Total No. Tests:");
        grandparentNode.appendChild(parent_node);
        var child_node = utr.CreateSpan("", uts.SUMMARY_CLASS + " offset", testObject.totalTestCount);
        parent_node.appendChild(child_node);

        parent_node = utr.CreateDiv("", uts.SUMMARY_CLASS, "Failed Tests:");
        grandparentNode.appendChild(parent_node);
        child_node = utr.CreateSpan("", uts.SUMMARY_CLASS + " offset", testObject.failedTestCount);
        parent_node.appendChild(child_node);

        parent_node = utr.CreateDiv("", uts.SUMMARY_CLASS, "Total Failures:");
        grandparentNode.appendChild(parent_node);
        child_node = utr.CreateSpan("", uts.SUMMARY_CLASS + " offset", testObject.failureCount);
        parent_node.appendChild(child_node);


        parent_node = utr.CreateDiv("", uts.SUMMARY_CLASS, "Elapsed Seconds:");
        grandparentNode.appendChild(parent_node);
        child_node = utr.CreateSpan("", uts.SUMMARY_CLASS + " offset", testObject.secondsElapsed);
        parent_node.appendChild(child_node);

        //totalTestCount: 1,failedTestCount: 1,failureCount: 2,secondsElapsed: 0.2,
    },

    CreateFullFailureMsg : function (childNode, messageArray)
    {
        var num_msgs = messageArray.length;

        for (var i = 0; i < num_msgs; ++i)
        {
            syn.AddTextToNode(messageArray[i], childNode);
            childNode.innerHTML += "<br>";
        }
    },


    CreateSpan : function (theId, classToUse, textToAdd)
    {
        var child_node = document.createElement("span");
        child_node.className = utr._rowHeightClass +" "+classToUse;
        child_node.id = theId;
        syn.AddTextToNode(textToAdd, child_node);
        return child_node;
    },

    CreateDiv : function (theId, classToUse, textToAdd)
    {
        var child_node = document.createElement("div");
        child_node.className = classToUse;
        child_node.id = theId;
        syn.AddTextToNode(textToAdd, child_node);
        return child_node;
    }

};
