if (typeof syn == 'undefined')
    throw("shell requires the syn Library from syncor.js");

var req = {
    Version                         : '1.0.0',
    // Constants for Making Ajax Requests
    REQUEST_CMD                : "request",
    MACHINE_STATE               : "machineState",
    SAMPLE_DATA                    : "sampleData",
    //    UNIT_TEST_DATA                : "unitTestData",
    DEBUG_OPTIONS                 : "debugOptions",
    EXAMPLE_SUITE           : "testSuite",
    SUITE_LIST                    : "suiteList"
};

var uts = new Object();

uts.SAMPLE_ID = "objectSample";
uts.UNIT_TEST_INFO_ID = "unitTestInfo";
uts.IMAGE_1_ID = "image1";
uts.IMAGE_2_ID = "image2";

uts.HEADER_CLASS = "header";
uts.NARROW_CLASS = "propValue narrow";
uts.WIDE_CLASS = "propValue wide";
uts.EXTRA_WIDE_CLASS = "propValue extraWide";
uts.STATUS_COL_CLASS = "statusCol";
uts.SUITE_NAME_COL_CLASS = "suiteNameCol";
uts.TEST_NAME_COL_CLASS = "testNameCol";
uts.ERROR_RESULT_COL_CLASS = "errorResultCol";

uts.SUMMARY_CLASS = "summaryData";
uts.NUMBER_TEST_RESULT_COLS = 4;

//uts.RunAllUnitTests = function()
//{
//    var request = syn.MakeUrlParmList(req.REQUEST_CMD, req.UNIT_TEST_DATA);
//    syn.MakeAjaxRequest(request, uts.CreateResultTable);
//};

uts.GetSuiteList = function ()
{
    var request = syn.MakeUrlParmList(req.REQUEST_CMD, req.SUITE_LIST);
    syn.MakeAjaxUnitTestRequest(request, utr.CreateSuiteList);
};

uts.RunSuite = function(suiteName)
{
    //Before running a test clear out any existing results so user has some feedback after the
    // first time
    var grandparent_node = $(uts.UNIT_TEST_INFO_ID);
    syn.AddTextToCleanNode("Running...", grandparent_node);
    var runner_node = $(utr.RUNNER_BAR_ID);
    runner_node.className = "runnerBar running";
    var page_title = $(utr.TEST_RUNNER_TITLE_ID);
    page_title.className = "TitleRight runningColor"; 

    var request = syn.MakeUrlParmList(req.REQUEST_CMD, req.EXAMPLE_SUITE, "suite=" + suiteName);
    syn.MakeAjaxUnitTestRequest(request, utr.CreateResultTable);
};


uts.CreateSampleData = function(resultData)
{
    _sampleData = syn.EvalJsonObject(resultData);

    $(uts.SAMPLE_ID).innerHTML = syn.DescribeObject(_sampleData);
    if (this._sampleData != null)
    {
        var the_node = $("objectSample");
        syn.AddTextToCleanNode(_sampleData.objName, the_node);
        syn.AddTextToNode("Total Test Count:" + _sampleData.totalTestCount, the_node);

        uts.CreateResultTable(resultData);

    }
};


