/*
 * JsonCreatorUt.h
 *
 *  Created on: Dec 11, 2009
 *      Author: Tod
 */

//=============================================================================
// The Class JsonCreator exists in the SyncorLibrary as well but I wanted to
// have the UnitTesting class be standalone (ie. not dependencies on other
// libraries). Therefore I changed the name of the class to JsonCreatorUt
// and IMPORTANTLY changed the name of the include Guards (because SyncorLibrary
// does use the UnitTest library.. This is a violation of DRY and if I find a bug
// in the piece of this class used by UnitTesting I will need to fix it both places.
// However, as I increase the capabilities of JsonCreator I don't have to update
// this version since it now has all the capabilities need by this library.
//=============================================================================

#ifndef JSONCREATORUT_H_
#define JSONCREATORUT_H_
#include <vector>
#include <string>
#include <sstream>

using std::string;
using std::ostringstream;

namespace UnitTest
{
	enum eValueHandler
	{
		vh_NORMAL, vh_STRING
	};

	const string NAME_VALUE_DELIM = ": ";
	const string STR_DELIM = "\"";
	const string ARRAY_DELIM_START = "[";
	const string ARRAY_DELIM_END = "]";

	class JsonCreatorUt
	{
		private:
			string BuildPropertyValueUt(string propValue, eValueHandler valueType) const;

		public:
			JsonCreatorUt(){};
			void AddPropertyUt(string propName, string propValue, eValueHandler valueType);

			template<typename T>
			void AddPropertyUt(string propName, T propValue)
			{
				ostringstream new_value;
				new_value << propValue;

				ostringstream new_property;
				new_property << propName << NAME_VALUE_DELIM;
				new_property << BuildPropertyValueUt(new_value.str(), vh_NORMAL);
				_properties.push_back(new_property.str());
			}

			void AddArrayPropertyUt(string propName, std::vector<string> propValues, eValueHandler valueType);
			//void CreateJsonObject();
			string GetJsonObjectUt();
			string GetPropertiesUt();
			void ClearPropertiesUt();

		private:
			static const char PROPERTY_DELIM = ',';

			std::vector<string> _properties;
			//ostringstream _jsonObject;

			void AddJsonPropertiesUt(ostringstream& destObj);
			//			void AddPropertyUt(string oneProperty);


	};

}
#endif /* JSONCREATORUT_H_ */
