/*
 * JsonTestReporter.h
 *
 *  Created on: Feb 2, 2010
 *      Author: Tod
 */

#ifndef JSONTESTREPORTER_H_
#define JSONTESTREPORTER_H_

#include "DeferredTestReporter.h"
#include <sstream>
#include <string>

#include "JsonCreatorUt.h"

//#include <iosfwd>
namespace UnitTest
{
	using std::string;

	class JsonTestReporter: public UnitTest::DeferredTestReporter
	{
		public:
			virtual void ReportSummary(int totalTestCount, int failedTestCount, int failureCount, float secondsElapsed);
			std::string GetReport()
			{
				return _jsonReport.str();
			}

		private:
			void AddFailure(const DeferredTestResult& result, std::vector<string>& failureMessages);

			string BuildFailureMessage(const string & file, int line, const string & message);
			std::vector<string> GetFailureMessageObjects();
			void AddTestResultsProperties(const DeferredTestResult& result, JsonCreatorUt& jc);

			std::ostringstream _jsonReport;

	};
}
#endif /* JSONTESTREPORTER_H_ */
