#ifndef UNITTEST_TIMEHELPERS_H
#define UNITTEST_TIMEHELPERS_H

#ifndef NotNetBurner
#include <basictypes.h>

namespace UnitTest
{
	class Timer
	{
		public:
			Timer();
			void Start();
			int GetTimeInMs() const;
			//default _maxFractionalCount is set to 39062 which was empirically
			//determined value for MOD5272 SetMaxFractionalCount allows user to
			//determine it for their hardware.
			uint32_t SetMaxFractionalCount();


		private:
			float GetTimeInTicks() const;

			float _startTime;
			uint32_t _frequency;
			float _maxFractionalCount;
	};

	namespace TimeHelpers
	{
		void SleepMs(int ms);
	}
}
#endif

#endif
